#!/usr/bin/python

# ctrtool
# Copyright (C) 2008 Christian Pellegrin <cripell@evolware.org>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys
import os
import dircache
import shutil

def get_list(path, name):
    r = []
    for i in dircache.listdir(path):
        if len(i) < len(name):
            continue
        else:
            ok = True
        for j in range(len(name)):
            if name[j] != '_' and name[j] != i[j]:
                ok = False
                break
        if ok:
            r.append(path + "/" + i)
    return r

# main

if len(sys.argv) < 4:
    print 'ctrt_collage.py [out dir] [repository dati] [cont 0/1/2] [quadri da fare ...]'
    sys.exit(1)

out_dir = sys.argv[1]
repository = sys.argv[2]
cont = int(sys.argv[3])
quadri = sys.argv[4:]

if cont == 2:
    ctrtool_mode = 'fast'
else:
    ctrtool_mode = 'map'

cartine_5000 = os.listdir(repository + '/5000')
cartine_25000 = os.listdir(repository + '/25000')

for i in quadri:
    shutil.rmtree(out_dir + "/imgs" + i, True)
    os.makedirs(out_dir + "/imgs" + i)

    mp = open(out_dir + "/imgs" + i + "/ctr.mp", mode="w")
    mp_hdr = open("preview.mp").read()
    mp.write(mp_hdr)
    for j in get_list(repository + '/5000/', '_' + i) + get_list(repository + '/25000/', '___' + i):
        cname = os.path.basename(j)[1:7]
        mp.write("img=%s.img\n"%(cname))
        img_file = out_dir + "/" + cname + "/img/" + cname + ".img"
        img_e = True
        try:
            img_t = open(img_file)
            img_t.close()
        except:
            img_e = False
        if cont != 1 or not img_e:
            cmd = ("./ctrtool.py " + j + " " + out_dir + " classi_solotopo img.mp " + ctrtool_mode)
            print cmd
            os.system(cmd)
            cwd = os.getcwd()
            os.chdir(out_dir + "/" + cname + "/img/")
            os. system("cgpsmapper-static -l " + cname + ".mp")
            os.chdir(cwd)
        os.symlink(img_file, out_dir + "/imgs" + i + "/" + cname + ".img")

    mp.write("[End]\n")
    mp.close()
    os.chdir(out_dir + "/imgs" + i + "/")
    os.system("cgpsmapper-static -l pv ctr.mp")
